import java.awt.*; import java.awt.event.*; import javax.swing.*;

/*
	MainFrame.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Managing the Game GUI and input as a whole.
	Allowed Dependencies: MainPanel.java
*/

public class MainFrame 	extends JFrame 
						implements 	ActionListener, KeyListener, 
									WindowFocusListener 
{
	Container c = getContentPane();	
		
	Timer timer;
    private JTextField prompt;
    	
	MainPanel screen; 
	
	WalkMap cur_map;
	
	private int ex = 100; //entity starting x coordinate!
	private int ey = 100; //ditto, now with y coordinate
	
	private int up = 0;
	private int down = 0;
	private int left = 0;
	private int right = 0;	

		
	public MainFrame(WalkMap cur_map)
	{
		this.setVisible(false);
		
		this.cur_map = cur_map;	
		
		Buffer.setCurMap(cur_map);

		screen = new MainPanel(cur_map,ex,ey);
				
		timer = new Timer(13, this); //Timer dealy.TWEAKABLE
		prompt = new JTextField("");

		screen.setBounds(0,0,360,240);
		       
		c.setLayout(null);

		c.add(screen);
		c.add(prompt);
										
		prompt.addKeyListener(this);
        this.addWindowFocusListener(this);
		
		this.setVisible(true);
		
		startAnimation();
	}	

	public synchronized void startAnimation() {
        timer.start();
    }


    public synchronized void stopAnimation() {
        timer.stop();
    }

    private int anim_delay = 20; //Animation delay per frame. TWEAKABLE
    private int anim_iterator = 0;

	/*
	 * DRAWING ROUTINE
	 */

    public void actionPerformed(ActionEvent e) {
        
		//Tile animation
        anim_iterator++;
        if(anim_iterator>=anim_delay) {
        	anim_iterator = 0;
        	Buffer.getCurMap().updateMap();
            Buffer.anim_toggle = 1 - Buffer.anim_toggle;
            Buffer.SF = Buffer.SF - (Buffer.SF%2) + Buffer.anim_toggle;
            screen.repaint();
            }           
        
        if(up>0 && ey>1) 
        	{ 
        	ey -= 2; screen.Update(ex,ey); 
        	if(Buffer.SF/2 != 0) { Buffer.SF = 0 + Buffer.anim_toggle; }
        	}
        if(down>0 && ey < (Buffer.getCurMap().getHeight()*24)-24)
        	{ 
        	ey += 2; screen.Update(ex,ey); 
        	if(Buffer.SF/2 != 2) { Buffer.SF = 4 + Buffer.anim_toggle; }
        	}    
        if(left>0 && ex>1) 
        	{ 
        	ex -= 2; screen.Update(ex,ey); 
        	if(Buffer.SF/2 != 3) { Buffer.SF = 6 + Buffer.anim_toggle; }
        	}
        if(right>0 && ex < (Buffer.getCurMap().getWidth()*24)-24) 
        	{ 
        	ex += 2; screen.Update(ex,ey); 
        	if(Buffer.SF/2 != 1) { Buffer.SF = 2 + Buffer.anim_toggle; }
        	}
   
        //Map repaint       
      	screen.repaint();
    } 
    
	public void keyPressed(KeyEvent e) {
		//Key controls
		int key = e.getKeyCode();
		
		//Press the arrow keys to initiate movement
		if(key == e.VK_UP) {
			up = 1;
			down = 0;
			//if(ey>5) { 
			//	ey -= 6;
			//	screen.Update(ex,ey); 
			//	}
			}
		if(key == e.VK_DOWN) {
			down = 1;
			up = 0;
			//if(ey < (Buffer.getCurMap().getHeight())*24-24) { 
			//	ey += 6;
			//	screen.Update(ex,ey); 
			//	}
			}	
		if(key == e.VK_LEFT) {
			left = 1;
			right = 0;
			//if(ex>5) { 
			//	ex -= 6; 
			//	screen.Update(ex,ey); 
			//	}
			}	
		if(key == e.VK_RIGHT) {
			right = 1;
			left = 0;
			//if(ex < (Buffer.getCurMap().getWidth())*24-24) { 
			//	ex += 6; 
			//	screen.Update(ex,ey); 
			//	}
			}	
			
		if(key == e.VK_F5) //Key F5 invokes a very simple refresh :)
			{
			this.paint(this.getGraphics());	
			}	
	}
	
	public void keyTyped(KeyEvent e) { }
	public void keyReleased(KeyEvent e) { 
		//Key controls
		int key = e.getKeyCode();
		
		//The arrow keys are used to scroll the map.
		if(key == e.VK_UP) { up = 0; }
		if(key == e.VK_DOWN) { down = 0; }	
		if(key == e.VK_LEFT) { left = 0; }	
		if(key == e.VK_RIGHT) {	right = 0; }	
	}
			
 	public void Refocus()
 	{
 		prompt.requestFocus();
 	}
 	
	public void windowGainedFocus(WindowEvent e) 
	{ 
	timer.start();				
	}
  	
  	public void windowLostFocus(WindowEvent e) { timer.stop(); } 
}	