import java.util.*; import java.awt.*; import java.io.*; import java.awt.image.*;
import javax.swing.*;
/*
	Tileset.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Interpreting Tileset resource files.
	-Managing the Tileset data structure and associated tiles for use in maps.
	Allowed Dependencies: Tile.java, Lib_Image.java
*/
public class Tileset implements Serializable
{
	private Vector tiles; //Contains all the tiles of the tileset.
	private int length; //Amount of different tiles in the tileset.
	
	public Tileset()
	{
		tiles = new Vector();
		for(int i=0;i<50;i++) {
			tiles.addElement(new Tile());
		}	
		
		this.length = tiles.size();
	}
	
	public Tileset(String sourcefile) 
	{	//Constructor
		tiles = new Vector();
		Image tileset = new ImageIcon(sourcefile).getImage();
    	int height = tileset.getHeight(null)/25;	
    	int width = tileset.getWidth(null)/25;		
    	
    	//For loop to scan tiles from gif file
    	for(int j=0;j<height;j++) {
    		for(int i=0;i<width;i++) {
    			tiles.addElement(new Tile(Lib_Image.cropImage(tileset, i*25, j*25, 24, 24))); 
    		}
    	}	
    	
    	this.length = tiles.size();
	}
	
	public Tile getTile(int index) {
		return (Tile) tiles.elementAt(index);
	}
	
	public void addTile()
	{
		tiles.addElement(new Tile());
		length++;
	}
	
	public void setTile(int index, Tile tile) {
		tiles.setElementAt((Object) tile, index);
	}
	
	public BufferedImage getTileContents(int index)	
	{	//Obtains data of specified tile
		
		//If the index is outside the Tile Vector
		if(index >= tiles.size()) {
			System.out.println("Tile #"+index+" does not reside in the tileset. Grabbing tile 0 instead");
			return getTileContents(0);
		}
		
		BufferedImage contents = Buffer.getTile(index);
		return contents;	
	
		
		//Otherwise
		//Tile t = (Tile) tiles.elementAt(index);
		//return t.getContents();
	}
	
	public int getLength() {
		return length;
	}
}